{***************************************************************
 *
 * Unit Name : DataCrack
 * Purpose   : Database Cracker
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 * Disclaimer: The objectives of this program is only educational.
 *             You MUST NOT use it without getting any material benefit on it
 *             You have the right to share this code with others without removing
 *             the copyright and/or disclaimer notice.
 *             You are allowed to include its code in your application
 *             only if it was designed for non commercial purpose,
 *             otherwise we claim $10 for each copy of your
 *             application which contains this code inside.
 ****************************************************************}

Unit DataCrack;

Interface

Uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Mask,
  DBCtrls,
  Db,
  DBTables,
  Spin,
  ComCtrls,
  IniFiles,
  ClipBrd;

Type
  TfrmCrackData = Class(TForm)
    btnNext: TButton;
    btnPrior: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    DBEdit13: TDBEdit;
    edtNume: TEdit;
    edtPrenume: TEdit;
    edtPrenumeExt: TEdit;
    edtNrStrada: TEdit;
    edtStrada: TEdit;
    edtLocalitate: TEdit;
    edtEtaj: TEdit;
    edtScara: TEdit;
    edtBloc: TEdit;
    edtTelefon: TEdit;
    edtPrefix: TEdit;
    edtCodLocalitate: TEdit;
    edtApartament: TEdit;
    Table1: TTable;
    DataSource1: TDataSource;
    Table1Nume: TStringField;
    Table1Prenume: TStringField;
    Table1PrenumeExt: TStringField;
    Table1Localitatea: TStringField;
    Table1Strada: TStringField;
    Table1NrStrada: TStringField;
    Table1CodLocalitate: TStringField;
    Table1PrefixTelefon: TStringField;
    Table1Telefon: TStringField;
    Table1Bloc: TStringField;
    Table1Scara: TStringField;
    Table1Etaj: TStringField;
    Table1Apartament: TStringField;
    edtPrior: TEdit;
    edtNext: TEdit;
    Label14: TLabel;
    SpinEdit1: TSpinEdit;
    ProgressBar1: TProgressBar;
    btnStart: TButton;
    btnStop: TButton;
    StatusBar1: TStatusBar;
    btnExit: TButton;
    CheckBox1: TCheckBox;
    btnGrupare: TButton;
    Label15: TLabel;
    SpinEdit2: TSpinEdit;
    Label16: TLabel;
    SpinEdit3: TSpinEdit;
    Procedure NextRecord(Sender: TObject);
    Procedure PriorRecord(Sender: TObject);
    Procedure btnExitClick(Sender: TObject);
    Procedure btnStartClick(Sender: TObject);
    Procedure btnStopClick(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCreate(Sender: TObject);
    Procedure btnGrupareClick(Sender: TObject);
  private
    Aborted: Boolean;
    Procedure CopyData(FromHandle, ToHandle: THandle);
    Procedure InsertNewRecord;
    Procedure start;
    Procedure EnableControls(Value: Boolean);
    Function CheckHandles: Boolean;
    Procedure StoreSettings;
    Procedure RestoreSettings;
    Procedure OpenDatabase(Value: String);
  public
    { Public declarations }
  End;

Var
  frmCrackData      : TfrmCrackData;

Implementation

Uses GrupareDlg;

{$R *.DFM}
//******************* TfrmCrackData.CopyData *************************

Procedure TfrmCrackData.CopyData(FromHandle, ToHandle: THandle);
Begin
  SendMessage(FromHandle, EM_SETSEL, 0, -1);
  SendMessage(FromHandle, WM_COPY, 0, 0);
  SendMessage(ToHandle, EM_SETSEL, 0, -1);
  SendMessage(ToHandle, WM_PASTE, 0, 0);
  Clipboard.Clear;
End;
//******************* TfrmCrackData.NextRecord *************************

Procedure TfrmCrackData.NextRecord(Sender: TObject);
Begin
  SendMessage(StrToInt(edtNext.Text), WM_LBUTTONDOWN, 0, 0);
  SendMessage(StrToInt(edtNext.Text), WM_LBUTTONUP, 0, 0);
End;
//******************* TfrmCrackData.PriorRecord *************************

Procedure TfrmCrackData.PriorRecord(Sender: TObject);
Begin
  SendMessage(StrToInt(edtPrior.Text), WM_LBUTTONDOWN, 0, 0);
  SendMessage(StrToInt(edtPrior.Text), WM_LBUTTONUP, 0, 0);
End;
//******************* TfrmCrackData.InsertNewRecord *************************

Procedure TfrmCrackData.InsertNewRecord;
Begin
  Table1.Append;
  CopyData(StrToInt(edtNume.Text), DBEdit1.Handle);
  CopyData(StrToInt(edtPrenume.Text), DBEdit2.Handle);
  CopyData(StrToInt(edtPrenumeExt.Text), DBEdit4.Handle);
  CopyData(StrToInt(edtLocalitate.Text), DBEdit3.Handle);
  CopyData(StrToInt(edtStrada.Text), DBEdit7.Handle);
  CopyData(StrToInt(edtNrStrada.Text), DBEdit8.Handle);
  CopyData(StrToInt(edtCodLocalitate.Text), DBEdit6.Handle);
  CopyData(StrToInt(edtPrefix.Text), DBEdit5.Handle);
  CopyData(StrToInt(edtTelefon.Text), DBEdit11.Handle);
  CopyData(StrToInt(edtBloc.Text), DBEdit12.Handle);
  CopyData(StrToInt(edtScara.Text), DBEdit10.Handle);
  CopyData(StrToInt(edtEtaj.Text), DBEdit9.Handle);
  CopyData(StrToInt(edtApartament.Text), DBEdit13.Handle);
  Table1.CheckBrowseMode;
End;
//******************* TfrmCrackData.Start *************************

Procedure TfrmCrackData.start;
Var
  I, j              : Integer;
Begin
  If Not CheckHandles Then
    Begin
      MessageDlg('Una dintre valorile introduse ca handlere ale componentelor ferestrei de date Pagini Aurii nu este de tip THandle.'#13#10'Operatie anulata.', mtWarning, [mbOK], 0);
      Exit;
    End;

  ProgressBar1.Position := 0;
  ProgressBar1.Max := SpinEdit1.Value - 1;
  ProgressBar1.Visible := True;
  j := SpinEdit3.Value;
  OpenDatabase(Format('D:\YellowData%d.DB', [j]));
  Inc(j);
  For I := SpinEdit2.Value To SpinEdit1.Value Do
    Begin
      If Aborted Then Break;
      If I Mod 50000 = 0 Then
        Begin
          OpenDatabase(Format('D:\YellowData%d.DB', [j]));
          Inc(j);
        End;
      InsertNewRecord;
      NextRecord(Self);
      ProgressBar1.Position := I;
      StatusBar1.Panels.Items[1].Text := Format('Procesez inregistrarea %d din %d.', [I, SpinEdit1.Value]);
      If WindowState = wsMinimized Then
        Application.Title := StatusBar1.Panels.Items[1].Text
      Else
        Application.Title := 'Pagini Aurii Database Crack';
      Application.ProcessMessages;
    End;
  Table1.Active := False;
  ProgressBar1.Visible := False;
  If Aborted Then MessageDlg('Operatie anulata de utilizator.', mtWarning, [mbOK], 0);
End;
//******************* TfrmCrackData.EnableControls *************************

Procedure TfrmCrackData.EnableControls(Value: Boolean);
Var
  I                 : Integer;
Begin
  For I := 0 To ControlCount - 1 Do
    If Controls[I] Is TEdit Then
      (Controls[I] As TEdit).Enabled := Value;
  SpinEdit1.Enabled := Value;
  btnPrior.Enabled := Value;
  btnNext.Enabled := Value;
  btnStart.Enabled := Value;
  btnStop.Enabled := Not Value;
  btnExit.Enabled := Value;
  btnGrupare.Enabled := Value;
End;
//******************* TfrmCrackData.btnExitClick *************************

Procedure TfrmCrackData.btnExitClick(Sender: TObject);
Begin
  Close;
End;
//******************* TfrmCrackData.CheckHandles *************************

Function TfrmCrackData.CheckHandles: Boolean;
Var
  I                 : Integer;
  Handle            : THandle;
Begin
  For I := 0 To ControlCount - 1 Do
    Begin
      If Controls[I] Is TEdit Then
        Try
          Handle := StrToInt((Controls[I] As TEdit).Text);
          Result := True;
        Except
          Result := False;
          Break;
        End;
    End;
End;
//******************* TfrmCrackData.btnStartClick *************************

Procedure TfrmCrackData.btnStartClick(Sender: TObject);
Begin
  Aborted := False;
  If CheckBox1.Checked Then StoreSettings;
  EnableControls(False);
  Try
    start;
  Except
    On E: Exception Do MessageDlg(E.Message, mtError, [mbOK], 0);
  End;
  EnableControls(True);
End;
//******************* TfrmCrackData.btnStopClick *************************

Procedure TfrmCrackData.btnStopClick(Sender: TObject);
Begin
  Aborted := MessageDlg('Sunteti sigur ca doriti anularea acestui proces?', mtConfirmation, [mbYes, mbNo], 0) = mrYes;
End;
//******************* TfrmCrackData.FormShow *************************

Procedure TfrmCrackData.FormShow(Sender: TObject);
Begin
  EnableControls(True);
  RestoreSettings;
End;
//******************* TfrmCrackData.StoreSettings *************************

Procedure TfrmCrackData.StoreSettings;
Var
  F                 : TIniFile;
Begin
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings.ini');
  Try
    F.WriteString('Handles', 'Nume', edtNume.Text);
    F.WriteString('Handles', 'Prenume', edtPrenume.Text);
    F.WriteString('Handles', 'PrenumeExt', edtPrenumeExt.Text);
    F.WriteString('Handles', 'Localitate', edtLocalitate.Text);
    F.WriteString('Handles', 'Strada', edtStrada.Text);
    F.WriteString('Handles', 'NrStrada', edtNrStrada.Text);
    F.WriteString('Handles', 'CodLocalitate', edtCodLocalitate.Text);
    F.WriteString('Handles', 'PrefixTelefon', edtPrefix.Text);
    F.WriteString('Handles', 'NrTelefon', edtTelefon.Text);
    F.WriteString('Handles', 'Bloc', edtBloc.Text);
    F.WriteString('Handles', 'Scara', edtScara.Text);
    F.WriteString('Handles', 'Etaj', edtEtaj.Text);
    F.WriteString('Handles', 'Apartament', edtApartament.Text);
    F.WriteString('Handles', 'Prior', edtPrior.Text);
    F.WriteString('Handles', 'Next', edtNext.Text);
    F.WriteInteger('Handles', 'Contor', SpinEdit1.Value);
    F.WriteInteger('Handles', 'ContorStart', SpinEdit2.Value);
    F.WriteInteger('Handles', 'ContorFisier', SpinEdit3.Value);
    F.WriteBool('Settings', 'Save', CheckBox1.Checked);
  Finally
    F.Free;
  End;
End;
//******************* TfrmCrackData.RestoreSettings *************************

Procedure TfrmCrackData.RestoreSettings;
Var
  F                 : TIniFile;
Begin
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings.ini');
  Try
    CheckBox1.Checked := F.ReadBool('Settings', 'Save', False);
    If CheckBox1.Checked Then
      Begin
        edtNume.Text := F.ReadString('Handles', 'Nume', '');
        edtPrenume.Text := F.ReadString('Handles', 'Prenume', '');
        edtPrenumeExt.Text := F.ReadString('Handles', 'PrenumeExt', '');
        edtLocalitate.Text := F.ReadString('Handles', 'Localitate', '');
        edtStrada.Text := F.ReadString('Handles', 'Strada', '');
        edtNrStrada.Text := F.ReadString('Handles', 'NrStrada', '');
        edtCodLocalitate.Text := F.ReadString('Handles', 'CodLocalitate', '');
        edtPrefix.Text := F.ReadString('Handles', 'PrefixTelefon', '');
        edtTelefon.Text := F.ReadString('Handles', 'NrTelefon', '');
        edtBloc.Text := F.ReadString('Handles', 'Bloc', '');
        edtScara.Text := F.ReadString('Handles', 'Scara', '');
        edtEtaj.Text := F.ReadString('Handles', 'Etaj', '');
        edtApartament.Text := F.ReadString('Handles', 'Apartament', '');
        edtPrior.Text := F.ReadString('Handles', 'Prior', '');
        edtNext.Text := F.ReadString('Handles', 'Next', '');
        SpinEdit1.Value := F.ReadInteger('Handles', 'Contor', 1);
        SpinEdit2.Value := F.ReadInteger('Handles', 'ContorStart', 1);
        SpinEdit3.Value := F.ReadInteger('Handles', 'ContorFisier', 1);
      End;
  Finally
    F.Free;
  End;
End;
//******************* TfrmCrackData.FormClose *************************

Procedure TfrmCrackData.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  StoreSettings;
End;
//******************* TfrmCrackData.OpenDatabase *************************

Procedure TfrmCrackData.OpenDatabase(Value: String);
Begin
  Table1.Active := False;
  Table1.TableName := Value;
  If fileexists(Table1.TableName) Then
    Begin
      If Not Table1.IsEmpty Then
        Begin
          Table1.Active := False;
          Table1.Exclusive := True;
          Table1.EmptyTable;
          Table1.Exclusive := False;
        End;
    End
  Else
    Table1.CreateTable;
  Table1.Active := True;
End;
//******************* TfrmCrackData.FormCreate *************************

Procedure TfrmCrackData.FormCreate(Sender: TObject);
Begin
  ProgressBar1.Parent := StatusBar1;
  ProgressBar1.Left := 1;
  ProgressBar1.Top := 2;
End;
//******************* TfrmCrackData.btnGrupareClick *************************

Procedure TfrmCrackData.btnGrupareClick(Sender: TObject);
Begin
  frmGrupare := TfrmGrupare.Create(Self);
  Try
    frmGrupare.ShowModal;
  Finally
    frmGrupare.Free;
  End;
End;

End.

